package hexentanz;
import gamelib.loadsave;
/**
 *
 * @author ujaso
 */
public class sprite
{
  public int id,ix,iy,iz,breite,hoehe,phase,typ,pic;
  public float x,y,vx,vy;
  public int[] poly; // beschreibendes Polygon für Collision Detect,counted Array
  
  public sprite(int nr)
  { poly=new int[65];
    id=nr; phase=0; typ=0; vx=0; vy=0; x=0; y=0; ix=0; iy=0; iz=nr; poly[0]=4;
  }
  public void on()  { typ=Math.abs(typ); }
  public void off() { typ=-Math.abs(typ); }
  public void set_typ(int nr) { typ=nr; }
  public void set_pic(int nr) { pic=nr; }
  public void set_speed(float vvx, float vvy) { vx=vvx; vy=vvy; }
  public void set_size(int ix,int iy)
  { breite=ix; hoehe=iy;
    poly[0]=4; poly[1]=0; poly[2]=0; poly[3]=breite; poly[4]=0;
    poly[5]=breite; poly[6]=hoehe; poly[7]=0; poly[8]=hoehe;
  }
  public void set_koords(float xx, float yy, int prio) { x=xx; y=yy; ix=Math.round(x); iy=Math.round(y); iz=prio; }
  public void set_koords(int xx, int yy, int zz) { ix=xx; iy=yy; iz=zz; x=(float)(ix); y=(float)(iy);  }
  public void move() { x=x+vx; y=y+vy; set_koords(x,y,iz); }

  public int get_breite() { return breite; }
  public int get_hoehe()  { return hoehe; }
  public int get_x()      { return ix; }
  public int get_y()      { return iy; }
  public int get_vx()     { return Math.round(vx); }
  public int get_vy()     { return Math.round(vy); }
  public int get_typ()    { return typ; }

  // Kollisionsdetektion:
  // Vierecke überlappen, wenn Mittelpunkte näher zusammen als Mittelwert der entsprechenden Dimension
  public boolean in_rect(int xx, int yy, int bb, int hh)
  { int mittex0=ix+breite/2,mittey0=iy+hoehe/2,mittex1=xx+bb/2,mittey1=yy+hh/2;
    int streckex=(breite+bb)/2,streckey=(hoehe+hh)/2;
    return ((Math.abs(mittex0-mittex1)<streckex) && (Math.abs(mittey0-mittey1)<streckey));
  }
  // Polygone überlappen, wenn mindestens 1 Eckpukt innerhalb des anderen Polygons liegt
  // Da ein Polygon auch vollständig in dem anderen liegen kann, müssen beide Sprites getestet werden
  public boolean in_poly(int xx, int yy)
  { int i,i1; // Hotspot: Spritemitte
    double x0=(double)xx,x1,x2,y0=(double)yy,y1,y2,sum=0.0;
    int[] ptrans=new int[poly[0]];
    // Transformation der Stossmaske um ix/iy (aktuelle Koordinaten):
    ptrans[0]=poly[0];
    for (i=1; i<ptrans[0]; i++) if (i%2>0) ptrans[i]=poly[i]+ix; else ptrans[i]=poly[i]+iy;
    // Winkel ptrans1--ptrans2 um xx/yy aufsummieren: drin: +-2*pi, draussen=0
    // Es könnte Probleme geben, wenn der Hotspot auf eine Ecke fällt, (sin=0)
    // in diesem Fall wird das Ganze aber von der ecma-262 Definition für atan2 aufgefangen.
    for (i=1; i<=poly[0]; i++)
    { x1=poly[2*i-1]; y1=poly[2*i];
      i1=2*i+1; if (i1>poly[0]) i1=1;
      x2=poly[i1]; y2=poly[i1+1];
      sum=sum+Math.atan2(x1-x0,y1-y0)-Math.atan2(x2-x0,y2-y0);// hier: Reihenfolge dx,dy! (vgl.Javascript)
    }
    return (Math.abs(sum)>0.000001);
  }

  // Stoßmaske als Polygon:
  public void set_poly(int[]a) { for (int i=0; i<a.length; i++) poly[i]=a[i]; } // aus deep copy
  public void set_poly(String filnam)  // aus Datei
  { loadsave fh=new loadsave();
    String[] zeile=fh.get_ressourcelines(filnam);
    zeile=zeile[0].split(",");
    for (int i=0; i<zeile.length; i++) poly[i]=Integer.parseInt(zeile[i]);
  }

}
