// ===============================================================================================
package gamelib;

import java.io.*;

public class loadsave {

  public loadsave() {
  }

  public String get_file(String fil) {
    return loadfile(fil);
  }

  public String[] get_lines(String fil) {
    return loadfile(fil).split("\n");
  }

  public String get_ressource(String fil) {
    return loadressource(fil);
  }

  public String[] get_ressourcelines(String fil) {
    return loadressource(fil).split("\n");
  }

  public void set_file(String fil, String inhalt) {
    savefile(fil, inhalt);
  }

  public void set_file(String fil, String[] inhalt) {
    String t = "";
    for (int i = 0; i < inhalt.length; i++) {
      t = t + inhalt[i] + "\n";
    }
    savefile(fil, t);
  }

// ===========================================================================================================
  String loadfile(String infile) {
    String s, t = "";
    try {
      BufferedReader in = new BufferedReader(new InputStreamReader(new FileInputStream(infile), "UTF8"));
      do {
        s = in.readLine();
        if (s != null) {
          t = t + s + "\n";
        }
      } while (s != null);
      in.close();
    } catch (IOException e) {
      System.out.println(">>> loadsave: " + infile + " not found");
    }
    return t;
  }

  String loadressource(String infile) {
    String s, t = "";
    try {
      InputStream ips = getClass().getResourceAsStream(infile);
      BufferedReader in = new BufferedReader(new InputStreamReader(ips, "UTF8"));
      do {
        s = in.readLine();
        if (s != null) {
          t = t + s + "\n";
        }
      } while (s != null);
      in.close();
    } catch (NullPointerException e) {
      System.out.println(">>> loadsave: ressource " + infile + " not found");
    } catch (IOException e) {
      System.out.println(">>> loadsave: ressource " + infile + " not found or has wrong format");
    }
    return t;
  }

  void savefile(String outfil, String inhalt) {
    try {
      BufferedWriter out = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(outfil), "UTF8"));
      out.write(inhalt);
      out.close();
    } catch (UnsupportedEncodingException e) {
      System.out.println(">>> loadsave: no UTF-8 upport");
    } catch (IOException e) {
      System.out.println(">>> loadsave: Could not write " + outfil);
    }
  }
}
