// Java-Soundmodul by uja 26.10.07
// Generierung my_sound=new sound(ressourcenpfad,wavliste);
// Aufruf: my_sound.play_sound(nr);
// Addition loop und Debug: uja 20.10.2010
// -------------------------------------------------------------------------------------------------------

package gamelib;
import java.io.*;
import javax.sound.sampled.*;

public class sound
{
  Clip[] saund; // Sound-Effekt-Puffer
  // LineListener kuckuck=new LineListener() { public void update(LineEvent e) { zeichmal(e); } }; // zu Testzwecken

  public sound(String pfad, String[] waves)
  { saund=new Clip[waves.length];
    for (int i=0; i<waves.length; i++)
    { try
      { // aus Jar laden:
        AudioInputStream ais=AudioSystem.getAudioInputStream(this.getClass().getResourceAsStream(pfad+waves[i]));
        AudioFormat af = ais.getFormat();
       // Clip erzeugen und oeffnen, dabei in Frames umrechnen
        DataLine.Info info = new DataLine.Info(Clip.class,af,((int) ais.getFrameLength()*af.getFrameSize()) );
        saund[i] = (Clip)AudioSystem.getLine(info);
        // saund[i].addLineListener(kuckuck); // zu Testzwecken
        // ready for use:
        saund[i].open(ais);
      }
      catch (Exception e) { System.out.println("Sound-Problem bei: "+pfad+waves[i]); }
    }
  }

  public void loop_sound(int nr) { saund[nr].loop(Clip.LOOP_CONTINUOUSLY); } // repeat forever
  public void stop_loop(int nr)  { saund[nr].setFramePosition(saund[nr].getFrameLength()-1); saund[nr].loop(0); }
  public void play_sound(int nr) { saund[nr].setFramePosition(0); saund[nr].start(); }
  public void stop_sound(int nr) { saund[nr].stop(); }
  public void cont_sound(int nr) { saund[nr].start(); }
  public void close_soundall()   { for (int i=0; i<saund.length; i++) saund[i].close(); }

/*
  public void zeichmal(LineEvent le)
  { LineEvent.Type type = le.getType();
    if (type == LineEvent.Type.OPEN) System.out.println("OPEN");
     else if (type == LineEvent.Type.CLOSE) System.out.println("CLOSE");
     else if (type == LineEvent.Type.START) System.out.println("START");
     else if (type == LineEvent.Type.STOP) System.out.println("STOP");
  }
 */

} 